% reference model
N = 600;
yo = ones(N,1);
yo(floor(N/2)+1:end) = 2;

yo = square(2*pi*0.005*[1:1000]);

ym = zeros(N,1);
ao = -0.7;
bo = 0.3;
for k=2:N
   ym(k) = -ao*ym(k-1) + bo*yo(k-1);
end

y   = zeros(N,1);
u   = zeros(N,1);
e   = zeros(N,1);
th1 = zeros(N,1);
th2 = zeros(N,1);
de1 = zeros(N,1);
de2 = zeros(N,1);
gamma = 1.75;
a = -0.5;
b = 0.1;
for k=2:N
   y(k) = -a*y(k-1) + b*u(k-1);
   e(k) = y(k)-ym(k);
   de1(k) = -ao*de1(k-1) + bo*yo(k-1);
   de2(k) = -ao*de2(k-1) - bo*y(k-1);
   %if k ==floor(N/2)+1, gamma=0; end
   th1(k) = th1(k-1) -gamma*e(k)*de1(k);
   th2(k) = th2(k-1) -gamma*e(k)*de2(k);
   u(k) = th1(k)*yo(k) - th2(k)*y(k); 
end
subplot(311),plot(1:N,ym,':',1:N,y,'-'),title('y (actual output) and y_m (ref. output)'),axis([0 N -1.1 1.1])
subplot(312),plot(1:N,th1,1:N,th2), title('\theta_1 and \theta_2')
subplot(313),plot(1:N,a+b*th2,1:N,th1*b,1:N,ao*ones(N,1),'k:',1:N,bo*ones(N,1),'k:'),title('Estimates of a and b')
