% Sistema
a = 0.8;
b = 0.2;
th_o = [a; b];
N = 50;
y_o = sin(2*pi*[0:N]/25);
ff = 0.95;

th_hat = zeros(2,N);
th_hat(:,1) = [0.8 0.8]'; %randn(2,1);
u = zeros(N,1);
y = zeros(N,1);
phi = zeros(2,N);
S = eye(2);
for t=2:N
    a_hat = th_hat(1,t-1);
    b_hat = th_hat(2,t-1);
    u(t-1) = (1/b_hat)*(y_o(t)-a_hat*y(t-1));
    phi(:,t) = [y(t-1); u(t-1)];
    y(t) = phi(:,t)'*th_o;
    err(t) = y(t)-phi(:,t)'*th_hat(:,t-1);
    S = ff*S + phi(:,t)*phi(:,t)'; 
    th_hat(:,t) = th_hat(:,t-1) + inv(S)*phi(:,t)*err(t);
end
a_hat = th_hat(1,t);
b_hat = th_hat(2,t);
u(t) = (1/b_hat)*(y_o(t)-a_hat*y(t));

figure(1)
subplot(211),plot(0:N-1,th_hat(1,1:N),0:N-1,ones(N,1)*a,':')
ylabel('$\hat{a}(t)$','interpreter','latex','fontsize',14)
axis([0 N 0 1])
subplot(212),plot(0:N-1,th_hat(2,1:N),0:N-1,ones(N,1)*b,':')
ylabel('$\hat{b}(t)$','interpreter','latex','fontsize',14)
axis([0 N 0 1])

figure(2)
subplot(211),plot(0:N-1,y,0:N,y_o,':')
ylabel('$y(t)$','interpreter','latex','fontsize',14)
axis([0 N -1.5 1.5])
subplot(212),plot(0:N-1,th_hat(2,1:N)./(1-th_hat(1,1:N)),0:N-1,ones(N,1)*b/(1-a),':')
ylabel('$\hat{\mu}(t)$','interpreter','latex','fontsize',14)
axis([0 N 0 5])

figure(3)
for a_hat0 = a+[-0.8:0.4:0.8]
    for b_hat0 = b+[-0.8:0.4:0.8]
        th_hat = zeros(2,N);
        th_hat(:,1) = [a_hat0 b_hat0]';
        u = zeros(N,1);
        y = zeros(N,1);
        phi = zeros(2,N);
        S = eye(2);
        for t=2:N
            a_hat = th_hat(1,t-1);
            b_hat = th_hat(2,t-1);
            u(t-1) = (1/b_hat)*(y_o(t)-a_hat*y(t-1));
            phi(:,t) = [y(t-1); u(t-1)];
            y(t) = phi(:,t)'*th_o;
            err(t) = y(t)-phi(:,t)'*th_hat(:,t-1);
            S = ff*S + phi(:,t)*phi(:,t)';
            th_hat(:,t) = th_hat(:,t-1) + inv(S)*phi(:,t)*err(t);
        end
        plot(th_hat(1,:)-a,th_hat(2,:)-b)
        hold on
        plot(th_hat(1,1)-a,th_hat(2,1)-b,'.','markersize',12)
        plot(th_hat(1,end)-a,th_hat(2,end)-b,'.','markersize',20)
    end
end
hold off
grid
xlabel('$\hat{a}(t)-a^o$','interpreter','latex','fontsize',14)
ylabel('$\hat{b}(t)-b^o$','interpreter','latex','fontsize',14)
