% Sistema 2 (ELS va male, RML va bene)
a1 = -0.9;
a2 = -0.95;
c1 = 1.5;
c2 = 0.75;

th_o = [a1 a2 c1 c2]';
lambda = 1;
N = 10000;

e = randn(N,1)*lambda;
y = zeros(N,1);
y(1) = e(1);
y(2) = a1*y(1)+e(2)+c1*e(1);
for t=3:N
  y(t) = a1*y(t-1)+a2*y(t-2)+e(t)+c1*e(t-1)+c2*e(t-2);
end;

% Inizializzazione
th0 = zeros(4,1);
V0 = 100*eye(4);

th_els = rplr(y,[2 2],'ff',1,th0,V0);
th_rml = rarmax(y,[2 2],'ff',1,th0,V0);
th_els(:,1:2) = -th_els(:,1:2);
th_rml(:,1:2) = -th_rml(:,1:2);

for i=1:4
  subplot(2,2,i),plot(1:N,th_rml(:,i),'b',1:N,th_els(:,i),'r',[1 N],th_o(i)*[1 1],':')
  axis([1 N round(th_o(i))+[-1 1]])
  switch i
      case 1, ylabel('a_1'), axis([0 N -2 0])
      case 2, ylabel('a_2'), axis([0 N -2 0])
      case 3, ylabel('c_1'), axis([0 N 0.5 2.5])
      case 4, ylabel('c_2'), axis([0 N -0.5 1.5])
  end
end

% Verifica condizione di reale positivit
w=-pi:0.01:pi;
figure, plot(w,1 + th_o(3)*cos(w) + th_o(4)*cos(2*w))
axis([-pi pi -.5 3.5])