th1 = [ones(1,400) sin(pi*[401:1000]/100+pi/2)]';
th2 = ones(1000,1);
u1  = randn(1000,1)*10; 
u2  = randn(1000,1)*10;
e   = randn(1000,1);

y   = th1.*u1 + th2.*u2 + e;

% RLS
mu_v = [1 0.95 0.75]
for ind_mu=1:3
   mu = mu_v(ind_mu);
   th_hat = [1; 1];
   V = eye(2)*0.1;
   for t = 1:1000
      phi = [u1(t) u2(t)]';
      epsilon(t) = y(t) - phi'*th_hat(:,end);
      V = (1/mu)*(V - V*phi*phi'*V/(mu + phi'*V*phi));
      K = V*phi;
      th_hat = [th_hat th_hat(:,end) + K*epsilon(t)];
   end
   figure(ind_mu)
   subplot(121),plot(1:1000,th1,'k:',0:1000,th_hat(1,:)), axis([0 1000 -1.1 1.1]), xlabel('\theta_1'),ylabel(['RLS with \mu = ' num2str(mu)])
   subplot(122),plot(1:1000,th2,'k:',0:1000,th_hat(2,:)), axis([0 1000 -1.1 1.1]), xlabel('\theta_2')
end