th1 = ones(1000,1);
th2 = ones(1000,1);
u1  = [randn(100,1); zeros(800,1); randn(100,1)];
u2  = randn(1000,1);
e   = randn(1000,1)*0.1;

y   = th1.*u1 + th2.*u2 + e;

% RLS
mu = 0.9;
th_hat = [1; 1];
V = eye(2)*0.1;
for t = 1:1000
   phi = [u1(t) u2(t)]';
   epsilon(t) = y(t) - phi'*th_hat(:,end);
   V = (1/mu)*(V - V*phi*phi'*V/(mu + phi'*V*phi));
   trS(t) = trace(inv(V));
   K = V*phi;
   th_hat = [th_hat th_hat(:,end) + K*epsilon(t)];
end
figure
plot(1:1000,th1,'k:',0:1000,th_hat(1,:)), axis([0 1000 -1.1 1.1]), xlabel('\theta_1'),ylabel(['RLS with \mu = ' num2str(mu)])
axis([800 1000 0 2])

return

% RLS + anti-burst
mu = 0.9;
th_hat = [1; 1];
V = eye(2)*0.1;
for t = 1:1000
   phi = [u1(t) u2(t)]';
   epsilon(t) = y(t) - phi'*th_hat(:,end);
   V = (1/mu)*(V - V*phi*phi'*V/(mu + phi'*V*phi));
   [M,Vd]=eig(V);
   Vd(find(Vd>0.5))=1;
   V = M*Vd*inv(M);
   eigV(t) = max(eig(V));
   trS(t) = trace(inv(V));
   K = V*phi;
   th_hat = [th_hat th_hat(:,end) + K*epsilon(t)];
end
figure
plot(1:1000,th1,'k:',0:1000,th_hat(1,:)), axis([0 1000 -1.1 1.1]), xlabel('\theta_1'),ylabel(['RLS with \mu = ' num2str(mu)])
axis([800 1000 0 2])